<template>
  <div>
    <v-container>
      <p class="display-2 font-weight-light	text-center pa-3">Регистрация</p>
      <v-form
        @submit.prevent="registerHandler"
        ref="form"
        v-model="valid"
        lazy-validation
      >
        <v-text-field
          v-model="username"
          :counter="150"
          :rules="usernameRules"
          label="Логин"
          required
        />
        <v-text-field
          v-model="email"
          :rules="emailRules"
          label="Email"
          required
        />
        <v-text-field
          v-model="password1"
          :rules="passwordRules"
          :type="'password'"
          label="Пароль"
        />
        <v-text-field
          v-model="password2"
          :rules="passwordRules"
          :type="'password'"
          label="Повторите пароль"
        />
        <v-btn
          :disabled="!valid"
          :type="'submit'"
          color="blue"
          class="mr-4"
          @click="check"
        >
          Зарегистрироваться
        </v-btn>
        <v-snackbar
          v-model="snackbar"
          timeout="3000"
          content-class="text-center"
        >
          {{ text }}
        </v-snackbar>
      </v-form>
    </v-container>
  </div>
</template>

<script>
export default {
  name: 'registration',
  computed: {
    check() {
      return this.error ? this.snackbar = true : this.snackbar = false
    }
  },
  data: () => ({
    snackbar: false,
    text: 'Пароли не совпадают',
    error: false,
    valid: false,
    username: '',
    usernameRules: [
      v => !!v || 'Name is required',
      v => (v && v.length <= 150 ) || 'Name must be less than 150 characters',
      v => (v && v.length >= 6 ) || 'Name must contain at least 6 characters'
    ],
    email: '',
    emailRules: [
      v => !!v || 'E-mail is required',
      v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
    ],
    password1: '',
    password2: '',
    passwordRules: [
      v => !!v || 'Password is required',
      v => (v && v.length >= 8 ) || 'Your password must contain at least 8 characters'
    ]
  }),
  created() {
    this.$setTitle('Регистрация')
  },
  methods: {
    registerHandler() {
      if (this.password1 === this.password2) {
        let username = this.username
        let email = this.email
        let password = this.password1
        this.$store.dispatch('register', { username, email, password })
          .then(() => this.$router.push('/check_mail'))
          .catch(err => console.log(err))
      } else {
        this.error = true
        console.log('Все хуйня, давай по-новой')
      }
    }
  }
}
</script>
